/**
 * @file   HLS.c.h
 * @author StepTechnica
 * @date   Nov 16 2023
 * 
 * @brief Evaluation Board 用ヘッダーファイル「HLS.c処理」
 * 
 * @copyright (C) 2022- StepTechnica Co.,Ltd.
 * 
 * このソフトウェアは、コピー利用、配布、変更の追加、変更を加えたもの再配布、商用利用、有料販売など、どなたも自由にお使いいただくことができます。
 * このソフトウェアには保証はついていません。
 * このソフトウェアを利用したことで問題が起きた際に、ソフトウェアの製作者は一切の責任を負いません。
 * 
 */

#ifndef CMD_HLS_H
#define CMD_HLS_H

/* -----------------------------------------------------------------------------
 * #defineマクロ定義
 */
#define MKY_BCR_SA_VALUE	0			// Satelight Address
#define MKY_BCR_BPS_VALUE	3			// BPS (12Mbps)
#define MKY_BCR_FH_VALUE	1			// Full Duplex
#define MKY_BCR_LF_VALUE	0			// Long Frame Select OFF
#define MKY_SCR_FS_VALUE	63			// Final Satelight


/* -----------------------------------------------------------------------------
 * 関数宣言
 */

extern void HLS_main(void);
extern void HLS_initialize(void);


#endif//CMD_HLS_H
